Index: trunk/SophyaLib/HiStats/histos2.cc
===================================================================
--- trunk/SophyaLib/HiStats/histos2.cc	(revision 1089)
+++ trunk/SophyaLib/HiStats/histos2.cc	(revision 1092)
@@ -43,54 +43,72 @@
   entre xMin,xMax et yMin,yMax.
 */
-Histo2D::Histo2D(float xMin, float xMax, int nxBin
-                ,float yMin, float yMax, int nyBin)
-      : data(new float[nxBin*nyBin]), err2(NULL)
+Histo2D::Histo2D(r_8 xMin,r_8 xMax,int_4 nxBin,r_8 yMin,r_8 yMax,int_4 nyBin)
+      : mData(new r_8[nxBin*nyBin]), mErr2(NULL)
       , nHist(0), nEntries(0)
-      , nx(nxBin), ny(nyBin), nxy(nxBin*nyBin)
-      , xmin(xMin), xmax(xMax), ymin(yMin), ymax(yMax)
-      , wbinx((xMax - xMin)/nxBin), wbiny((yMax - yMin)/nyBin)
-      , hprojx(NULL), hprojy(NULL)
+      , mNx(nxBin), mNy(nyBin), mNxy(nxBin*nyBin)
+      , mXmin(xMin), mXmax(xMax), mYmin(yMin), mYmax(yMax)
+      , mWBinx((xMax - xMin)/nxBin), mWBiny((yMax - yMin)/nyBin)
+      , mHprojx(NULL), mHprojy(NULL)
 {
 ASSERT(nxBin>0 && nyBin>0 && xMin<xMax && yMin<yMax);
-for(int i=0;i<3;i++) for(int j=0;j<3;j++) over[i][j]=0.;
+for(int_4 i=0;i<3;i++) for(int_4 j=0;j<3;j++) mOver[i][j]=0.;
 Zero();
-b_s.H = NULL;
+mB_s.H = NULL;
 END_CONSTRUCTOR
 }
 
 /*!
+  Createur d'un histogramme 2D ayant nxBin,nyBin bins
+  entre xMin,xMax et yMin,yMax.
+*/
+Histo2D::Histo2D(r_4 xMin,r_4 xMax,int_4 nxBin,r_4 yMin,r_4 yMax,int_4 nyBin)
+      : mData(new r_8[nxBin*nyBin]), mErr2(NULL)
+      , nHist(0), nEntries(0)
+      , mNx(nxBin), mNy(nyBin), mNxy(nxBin*nyBin)
+      , mXmin((r_8)xMin), mXmax((r_8)xMax), mYmin((r_8)yMin), mYmax((r_8)yMax)
+      , mWBinx((xMax - xMin)/nxBin), mWBiny((yMax - yMin)/nyBin)
+      , mHprojx(NULL), mHprojy(NULL)
+{
+ASSERT(nxBin>0 && nyBin>0 && xMin<xMax && yMin<yMax);
+for(int_4 i=0;i<3;i++) for(int_4 j=0;j<3;j++) mOver[i][j]=0.;
+Zero();
+mB_s.H = NULL;
+END_CONSTRUCTOR
+}
+
+/*!
   Constructeur par copie.
 */
 Histo2D::Histo2D(const Histo2D& h)
 {
-int i,j;
-data = new float[h.nxy];
-memcpy(data, h.data, h.nxy*sizeof(float));
-
-err2 = NULL;
-if(h.err2) {
-  err2 = new double[h.nxy];
-  memcpy(err2, h.err2, h.nxy*sizeof(double));
+int_4 i,j;
+mData = new r_8[h.mNxy];
+memcpy(mData, h.mData, h.mNxy*sizeof(r_8));
+
+mErr2 = NULL;
+if(h.mErr2) {
+  mErr2 = new r_8[h.mNxy];
+  memcpy(mErr2, h.mErr2, h.mNxy*sizeof(r_8));
 }
 
 nHist = h.nHist; nEntries = h.nEntries;
-for(i=0;i<3;i++) for(j=0;j<3;j++) over[i][j]=h.over[i][j];
-nx = h.nx;  ny = h.ny;  nxy = h.nxy;
-xmin = h.xmin; xmax = h.xmax; ymin = h.ymin; ymax = h.ymax;
-wbinx = h.wbinx; wbiny = h.wbiny;
-b_s.H = NULL;
-
-hprojx = hprojy = NULL;
-if(h.hprojx) {
+for(i=0;i<3;i++) for(j=0;j<3;j++) mOver[i][j]=h.mOver[i][j];
+mNx = h.mNx;  mNy = h.mNy;  mNxy = h.mNxy;
+mXmin = h.mXmin; mXmax = h.mXmax; mYmin = h.mYmin; mYmax = h.mYmax;
+mWBinx = h.mWBinx; mWBiny = h.mWBiny;
+mB_s.H = NULL;
+
+mHprojx = mHprojy = NULL;
+if(h.mHprojx) {
   SetProjX();
-  *hprojx = *(h.hprojx);
-}
-if(h.hprojy) {
+  *mHprojx = *(h.mHprojx);
+}
+if(h.mHprojy) {
   SetProjY();
-  *hprojy = *(h.hprojy); 
-}
-
-int nb;
-float min,max;
+  *mHprojy = *(h.mHprojy); 
+}
+
+int_4 nb;
+r_8 min,max;
 nb = h.NSliX();
 if(nb>0) {
@@ -130,13 +148,13 @@
 */
 Histo2D::Histo2D()
-      : data(NULL), err2(NULL)
+      : mData(NULL), mErr2(NULL)
       , nHist(0), nEntries(0)
-      , nx(0), ny(0), nxy(0)
-      , xmin(0), xmax(0), ymin(0), ymax(0)
-      , wbinx(0), wbiny(0)
-      , hprojx(NULL), hprojy(NULL)
-{
-for(int i=0;i<3;i++) for(int j=0;j<3;j++) over[i][j]=0.;
-b_s.H = NULL;
+      , mNx(0), mNy(0), mNxy(0)
+      , mXmin(0), mXmax(0), mYmin(0), mYmax(0)
+      , mWBinx(0), mWBiny(0)
+      , mHprojx(NULL), mHprojy(NULL)
+{
+for(int_4 i=0;i<3;i++) for(int_4 j=0;j<3;j++) mOver[i][j]=0.;
+mB_s.H = NULL;
 END_CONSTRUCTOR
 }
@@ -148,7 +166,7 @@
 void Histo2D::Delete()
 {
-  if( data != NULL ) { delete[] data; data = NULL;}
-
-  if( err2 != NULL ) { delete[] err2; err2 = NULL;}
+  if( mData != NULL ) { delete[] mData; mData = NULL;}
+
+  if( mErr2 != NULL ) { delete[] mErr2; mErr2 = NULL;}
 
   DelProj();
@@ -162,9 +180,9 @@
   nHist = 0;
   nEntries = 0;
-  nx = 0; ny = 0; nxy = 0;
-  xmin = 0; xmax = 0; ymin = 0; ymax = 0;
-  wbinx = 0; wbiny = 0;
-  for(int i=0;i<3;i++) for(int j=0;j<3;j++) over[i][j]=0.;
-  b_s.H = NULL;
+  mNx = 0; mNy = 0; mNxy = 0;
+  mXmin = 0; mXmax = 0; mYmin = 0; mYmax = 0;
+  mWBinx = 0; mWBiny = 0;
+  for(int_4 i=0;i<3;i++) for(int_4 j=0;j<3;j++) mOver[i][j]=0.;
+  mB_s.H = NULL;
 }
 
@@ -184,9 +202,9 @@
 {
   nHist = nEntries = 0;
-  for(int i=0;i<3;i++) for(int j=0;j<3;j++) over[i][j]=0.;
-  memset(data, 0, nxy*sizeof(float));
-  memset(over, 0, 9*sizeof(float));
-
-  if( err2 != NULL ) memset(err2, 0, nxy*sizeof(double));
+  for(int_4 i=0;i<3;i++) for(int_4 j=0;j<3;j++) mOver[i][j]=0.;
+  memset(mData, 0, mNxy*sizeof(r_8));
+  memset(mOver, 0, 9*sizeof(r_8));
+
+  if( mErr2 != NULL ) memset(mErr2, 0, mNxy*sizeof(r_8));
 
   ZeroProj();
@@ -205,7 +223,7 @@
 void Histo2D::Errors()
 {
- if( nxy > 0 ) {
-   if(err2==NULL) err2 = new double[nxy];
-   memset(err2, 0, nxy*sizeof(double));
+ if( mNxy > 0 ) {
+   if(mErr2==NULL) mErr2 = new r_8[mNxy];
+   memset(mErr2, 0, mNxy*sizeof(r_8));
  }
 }
@@ -217,32 +235,32 @@
 Histo2D& Histo2D::operator = (const Histo2D& h)
 {
-  int i,j,nb;
-  float min,max;
+  int_4 i,j,nb;
+  r_8 min,max;
 
   if(this == &h) return *this;
-  if( h.nxy > nxy ) Delete();
-  if(!data) data = new float[h.nxy];
-  if( !h.err2 && err2 ) { delete [] err2; err2=NULL;}
-  if( h.err2 && !err2 ) err2 = new double[h.nxy];
-
-  for(i=0;i<3;i++) for(j=0;j<3;j++) over[i][j] = h.over[i][j];
+  if( h.mNxy > mNxy ) Delete();
+  if(!mData) mData = new r_8[h.mNxy];
+  if( !h.mErr2 && mErr2 ) { delete [] mErr2; mErr2=NULL;}
+  if( h.mErr2 && !mErr2 ) mErr2 = new r_8[h.mNxy];
+
+  for(i=0;i<3;i++) for(j=0;j<3;j++) mOver[i][j] = h.mOver[i][j];
   nHist = h.nHist;
   nEntries = h.nEntries;
-  nx = h.nx;  ny = h.ny;  nxy = h.nxy;
-  xmin = h.xmin; xmax = h.xmax; wbinx = h.wbinx;
-  ymin = h.ymin; ymax = h.ymax; wbiny = h.wbiny;
+  mNx = h.mNx;  mNy = h.mNy;  mNxy = h.mNxy;
+  mXmin = h.mXmin; mXmax = h.mXmax; mWBinx = h.mWBinx;
+  mYmin = h.mYmin; mYmax = h.mYmax; mWBiny = h.mWBiny;
   
-  memcpy(data, h.data, nxy*sizeof(float));
-  if(err2) memcpy(err2, h.err2, nxy*sizeof(double));
+  memcpy(mData, h.mData, mNxy*sizeof(r_8));
+  if(mErr2) memcpy(mErr2, h.mErr2, mNxy*sizeof(r_8));
 
   DelProjX();
-  if(h.hprojx) {
+  if(h.mHprojx) {
     SetProjX();
-    *hprojx = *(h.hprojx);
+    *mHprojx = *(h.mHprojx);
   }
   DelProjY();
-  if(h.hprojy) {
+  if(h.mHprojy) {
     SetProjY();
-    *hprojy = *(h.hprojy);
+    *mHprojy = *(h.mHprojy);
   }
 
@@ -288,17 +306,17 @@
   Operateur H *= b
 */
-Histo2D& Histo2D::operator *= (double b)
-{
-int i,j;
-double b2 = b*b;
-for(i=0;i<nxy;i++) {
-  data[i] *= b;
-  if(err2) err2[i] *= b2;
-}
-for(i=0;i<3;i++) for(j=0;j<3;j++) over[i][j] *= b;
+Histo2D& Histo2D::operator *= (r_8 b)
+{
+int_4 i,j;
+r_8 b2 = b*b;
+for(i=0;i<mNxy;i++) {
+  mData[i] *= b;
+  if(mErr2) mErr2[i] *= b2;
+}
+for(i=0;i<3;i++) for(j=0;j<3;j++) mOver[i][j] *= b;
 nHist *= b;
 
-if(hprojx) *hprojx *= b;
-if(hprojy) *hprojy *= b;
+if(mHprojx) *mHprojx *= b;
+if(mHprojy) *mHprojy *= b;
 if(NSliX()>0) for(i=0; i<NSliX();i++) *HSliX(i) *= b;
 if(NSliY()>0) for(i=0; i<NSliY();i++) *HSliY(i) *= b;
@@ -312,18 +330,18 @@
   Operateur H /= b
 */
-Histo2D& Histo2D::operator /= (double b)
-{
-int i,j;
+Histo2D& Histo2D::operator /= (r_8 b)
+{
+int_4 i,j;
 if (b==0.) THROW(inconsistentErr);
-double b2 = b*b;
-for(i=0;i<nxy;i++) {
-  data[i] /= b;
-  if(err2) err2[i] /= b2;
-}
-for(i=0;i<3;i++) for(j=0;j<3;j++) over[i][j] /= b;
+r_8 b2 = b*b;
+for(i=0;i<mNxy;i++) {
+  mData[i] /= b;
+  if(mErr2) mErr2[i] /= b2;
+}
+for(i=0;i<3;i++) for(j=0;j<3;j++) mOver[i][j] /= b;
 nHist /= b;
 
-if(hprojx) *hprojx /= b;
-if(hprojy) *hprojy /= b;
+if(mHprojx) *mHprojx /= b;
+if(mHprojy) *mHprojy /= b;
 if(NSliX()>0) for(i=0; i<NSliX();i++) *HSliX(i) /= b;
 if(NSliY()>0) for(i=0; i<NSliY();i++) *HSliY(i) /= b;
@@ -337,23 +355,23 @@
   Operateur H += b
 */
-Histo2D& Histo2D::operator += (double b)
-{
-int i,j;
-float min,max;
-for(i=0;i<nxy;i++) data[i] += b;
-for(i=0;i<3;i++) for(j=0;j<3;j++) over[i][j] += b;
-nHist += nxy*b;
-
-if(hprojx) *hprojx += b*ny;
-if(hprojy) *hprojy += b*nx;
-if(NSliX()>0) for(i=0; i<NSliX();i++) *HSliX(i) += b*ny/NSliX();
-if(NSliY()>0) for(i=0; i<NSliY();i++) *HSliY(i) += b*nx/NSliY();
+Histo2D& Histo2D::operator += (r_8 b)
+{
+int_4 i,j;
+r_8 min,max;
+for(i=0;i<mNxy;i++) mData[i] += b;
+for(i=0;i<3;i++) for(j=0;j<3;j++) mOver[i][j] += b;
+nHist += mNxy*b;
+
+if(mHprojx) *mHprojx += b*mNy;
+if(mHprojy) *mHprojy += b*mNx;
+if(NSliX()>0) for(i=0; i<NSliX();i++) *HSliX(i) += b*mNy/NSliX();
+if(NSliY()>0) for(i=0; i<NSliY();i++) *HSliY(i) += b*mNx/NSliY();
 if(NBandX()>0) for(i=0; i<NBandX();i++) {
   GetBandX(i,min,max);
-  *HBandX(i) += b*(max-min)/(ymax-ymin)*ny;
+  *HBandX(i) += b*(max-min)/(mYmax-mYmin)*mNy;
 }
 if(NBandY()>0) for(i=0; i<NBandY();i++) {
   GetBandY(i,min,max);
-  *HBandY(i) += b*(max-min)/(xmax-xmin)*nx;
+  *HBandY(i) += b*(max-min)/(mXmax-mXmin)*mNx;
 }
 
@@ -364,23 +382,23 @@
   Operateur H -= b
 */
-Histo2D& Histo2D::operator -= (double b)
-{
-int i,j;
-float min,max;
-for(i=0;i<nxy;i++) data[i] -= b;
-for(i=0;i<3;i++) for(j=0;j<3;j++) over[i][j] -= b;
-nHist -= nxy*b;
-
-if(hprojx) *hprojx -= b*ny;
-if(hprojy) *hprojy -= b*nx;
-if(NSliX()>0) for(i=0; i<NSliX();i++) *HSliX(i) -= b*ny/NSliX();
-if(NSliY()>0) for(i=0; i<NSliY();i++) *HSliY(i) -= b*nx/NSliY();
+Histo2D& Histo2D::operator -= (r_8 b)
+{
+int_4 i,j;
+r_8 min,max;
+for(i=0;i<mNxy;i++) mData[i] -= b;
+for(i=0;i<3;i++) for(j=0;j<3;j++) mOver[i][j] -= b;
+nHist -= mNxy*b;
+
+if(mHprojx) *mHprojx -= b*mNy;
+if(mHprojy) *mHprojy -= b*mNx;
+if(NSliX()>0) for(i=0; i<NSliX();i++) *HSliX(i) -= b*mNy/NSliX();
+if(NSliY()>0) for(i=0; i<NSliY();i++) *HSliY(i) -= b*mNx/NSliY();
 if(NBandX()>0) for(i=0; i<NBandX();i++) {
   GetBandX(i,min,max);
-  *HBandX(i) -= b*(max-min)/(ymax-ymin)*ny;
+  *HBandX(i) -= b*(max-min)/(mYmax-mYmin)*mNy;
 }
 if(NBandY()>0) for(i=0; i<NBandY();i++) {
   GetBandY(i,min,max);
-  *HBandY(i) -= b*(max-min)/(xmax-xmin)*nx;
+  *HBandY(i) -= b*(max-min)/(mXmax-mXmin)*mNx;
 }
 
@@ -394,16 +412,16 @@
 Histo2D& Histo2D::operator += (const Histo2D& a)
 {
-int i,j;
-if(nx!=a.nx || ny!=a.ny) THROW(sizeMismatchErr);
-for(i=0;i<nxy;i++) {
-  data[i] += a.data[i];
-  if(err2 && a.err2) err2[i] += a.err2[i];
-}
-for(i=0;i<3;i++) for(j=0;j<3;j++) over[i][j] += a.over[i][j];
+int_4 i,j;
+if(mNx!=a.mNx || mNy!=a.mNy) THROW(sizeMismatchErr);
+for(i=0;i<mNxy;i++) {
+  mData[i] += a.mData[i];
+  if(mErr2 && a.mErr2) mErr2[i] += a.mErr2[i];
+}
+for(i=0;i<3;i++) for(j=0;j<3;j++) mOver[i][j] += a.mOver[i][j];
 nHist += a.nHist;
 nEntries += a.nEntries;
 
-if(hprojx && a.hprojx) *hprojx += *(a.hprojx);
-if(hprojy && a.hprojy) *hprojy += *(a.hprojy);
+if(mHprojx && a.mHprojx) *mHprojx += *(a.mHprojx);
+if(mHprojy && a.mHprojy) *mHprojy += *(a.mHprojy);
 ZeroSliX();  ZeroSliY();
 ZeroBandX(); ZeroBandY();
@@ -417,16 +435,16 @@
 Histo2D& Histo2D::operator -= (const Histo2D& a)
 {
-int i,j;
-if(nx!=a.nx || ny!=a.ny) THROW(sizeMismatchErr);
-for(i=0;i<nxy;i++) {
-  data[i] -= a.data[i];
-  if(err2 && a.err2) err2[i] += a.err2[i];
-}
-for(i=0;i<3;i++) for(j=0;j<3;j++) over[i][j] += a.over[i][j];
+int_4 i,j;
+if(mNx!=a.mNx || mNy!=a.mNy) THROW(sizeMismatchErr);
+for(i=0;i<mNxy;i++) {
+  mData[i] -= a.mData[i];
+  if(mErr2 && a.mErr2) mErr2[i] += a.mErr2[i];
+}
+for(i=0;i<3;i++) for(j=0;j<3;j++) mOver[i][j] += a.mOver[i][j];
 nHist -= a.nHist;
 nEntries += a.nEntries;
 
-if(hprojx && a.hprojx) *hprojx -= *(a.hprojx);
-if(hprojy && a.hprojy) *hprojy -= *(a.hprojy);
+if(mHprojx && a.mHprojx) *mHprojx -= *(a.mHprojx);
+if(mHprojy && a.mHprojy) *mHprojy -= *(a.mHprojy);
 ZeroSliX();  ZeroSliY();
 ZeroBandX(); ZeroBandY();
@@ -440,18 +458,18 @@
 Histo2D& Histo2D::operator *= (const Histo2D& a)
 {
-int i,j;
-if(nx!=a.nx || ny!=a.ny) THROW(sizeMismatchErr);
+int_4 i,j;
+if(mNx!=a.mNx || mNy!=a.mNy) THROW(sizeMismatchErr);
 nHist = 0.;
-for(i=0;i<nxy;i++) {
-  if(err2 && a.err2)
-      err2[i] = a.data[i]*a.data[i]*err2[i] + data[i]*data[i]*a.err2[i];
-  data[i] *= a.data[i];
-  nHist += data[i];
-}
-for(i=0;i<3;i++) for(j=0;j<3;j++) over[i][j] *= a.over[i][j];
+for(i=0;i<mNxy;i++) {
+  if(mErr2 && a.mErr2)
+      mErr2[i] = a.mData[i]*a.mData[i]*mErr2[i] + mData[i]*mData[i]*a.mErr2[i];
+  mData[i] *= a.mData[i];
+  nHist += mData[i];
+}
+for(i=0;i<3;i++) for(j=0;j<3;j++) mOver[i][j] *= a.mOver[i][j];
 nEntries += a.nEntries;
 
-if(hprojx && a.hprojx) *hprojx *= *(a.hprojx);
-if(hprojy && a.hprojy) *hprojy *= *(a.hprojy);
+if(mHprojx && a.mHprojx) *mHprojx *= *(a.mHprojx);
+if(mHprojy && a.mHprojy) *mHprojy *= *(a.mHprojy);
 ZeroSliX();  ZeroSliY();
 ZeroBandX(); ZeroBandY();
@@ -465,25 +483,25 @@
 Histo2D& Histo2D::operator /= (const Histo2D& a)
 {
-int i,j;
-if(nx!=a.nx || ny!=a.ny) THROW(sizeMismatchErr);
+int_4 i,j;
+if(mNx!=a.mNx || mNy!=a.mNy) THROW(sizeMismatchErr);
 nHist = 0.;
-for(i=0;i<nxy;i++) {
-  if(a.data[i]==0.) {
-    data[i]=0.;
-    if(err2) err2[i]=0.;
+for(i=0;i<mNxy;i++) {
+  if(a.mData[i]==0.) {
+    mData[i]=0.;
+    if(mErr2) mErr2[i]=0.;
     continue;
   }
-  if(err2 && a.err2)
-      err2[i] = (err2[i] + data[i]/a.data[i]*data[i]/a.data[i]*a.err2[i])
-                /(a.data[i]*a.data[i]);
-  data[i] /= a.data[i];
-  nHist += data[i];
+  if(mErr2 && a.mErr2)
+      mErr2[i] = (mErr2[i] + mData[i]/a.mData[i]*mData[i]/a.mData[i]*a.mErr2[i])
+                /(a.mData[i]*a.mData[i]);
+  mData[i] /= a.mData[i];
+  nHist += mData[i];
 }
 for(i=0;i<3;i++) for(j=0;j<3;j++) 
-  if(a.over[i][j]!=0.) over[i][j] *= a.over[i][j]; else over[i][j] = 0.;
+  if(a.mOver[i][j]!=0.) mOver[i][j] *= a.mOver[i][j]; else mOver[i][j] = 0.;
 nEntries += a.nEntries;
 
-if(hprojx && a.hprojx) *hprojx /= *(a.hprojx);
-if(hprojy && a.hprojy) *hprojy /= *(a.hprojy);
+if(mHprojx && a.mHprojx) *mHprojx /= *(a.mHprojx);
+if(mHprojy && a.mHprojy) *mHprojy /= *(a.mHprojy);
 ZeroSliX();  ZeroSliY();
 ZeroBandX(); ZeroBandY();
@@ -498,7 +516,7 @@
 void Histo2D::GetXCoor(TVector<r_8> &v)
 {
-float x,y;
-v.Realloc(nx);
-for(int i=0;i<nx;i++) {BinLowEdge(i,0,x,y); v(i) = x;}
+r_8 x,y;
+v.Realloc(mNx);
+for(int_4 i=0;i<mNx;i++) {BinLowEdge(i,0,x,y); v(i) = x;}
 return;
 }
@@ -509,7 +527,7 @@
 void Histo2D::GetYCoor(TVector<r_8> &v)
 {
-float x,y;
-v.Realloc(ny);
-for(int i=0;i<ny;i++) {BinLowEdge(0,i,x,y); v(i) = y;}
+r_8 x,y;
+v.Realloc(mNy);
+for(int_4 i=0;i<mNy;i++) {BinLowEdge(0,i,x,y); v(i) = y;}
 return;
 }
@@ -520,7 +538,7 @@
 void Histo2D::GetValue(TMatrix<r_8> &v)
 {
-v.Realloc(nx,ny);
-for(int i=0;i<nx;i++)
-  for(int j=0;j<ny;j++) v(i,j) = (*this)(i,j);
+v.Realloc(mNx,mNy);
+for(int_4 i=0;i<mNx;i++)
+  for(int_4 j=0;j<mNy;j++) v(i,j) = (*this)(i,j);
 return;
 }
@@ -531,9 +549,9 @@
 void Histo2D::GetError2(TMatrix<r_8> &v)
 {
-int i,j;
-v.Realloc(nx,ny);
-if(!err2)
-  {for(i=0;i<nx;i++) for(j=0;j<ny;j++) v(i,j) = 0.; return;}
-for(i=0;i<nx;i++) for(j=0;j<ny;j++) v(i,j) = Error2(i,j);
+int_4 i,j;
+v.Realloc(mNx,mNy);
+if(!mErr2)
+  {for(i=0;i<mNx;i++) for(j=0;j<mNy;j++) v(i,j) = 0.; return;}
+for(i=0;i<mNx;i++) for(j=0;j<mNy;j++) v(i,j) = Error2(i,j);
 return;
 }
@@ -544,9 +562,9 @@
 void Histo2D::GetError(TMatrix<r_8> &v)
 {
-int i,j;
-v.Realloc(nx,ny);
-if(!err2)
-  {for(i=0;i<nx;i++) for(j=0;j<ny;j++) v(i,j) = 0.; return;}
-for(i=0;i<nx;i++) for(j=0;j<ny;j++) v(i,j) = Error(i,j);
+int_4 i,j;
+v.Realloc(mNx,mNy);
+if(!mErr2)
+  {for(i=0;i<mNx;i++) for(j=0;j<mNy;j++) v(i,j) = 0.; return;}
+for(i=0;i<mNx;i++) for(j=0;j<mNy;j++) v(i,j) = Error(i,j);
 return;
 }
@@ -556,13 +574,12 @@
   Remplissage du contenu de l'histo avec les valeurs d'un tableau.
 */
-void Histo2D::PutValue(TMatrix<r_8> &v, int ierr)
-{
-int i,j;
-//if(v.NRows()!=(uint_4)nx || v.NCol()!=(uint_4)ny) THROW(sizeMismatchErr);
-uint_4 nnx = (v.NRows()<(uint_4)nx)? v.NRows(): (uint_4)nx;
-uint_4 nny = (v.NCol() <(uint_4)ny)? v.NCol() : (uint_4)ny;
-if(nnx>0 && nny>0) for(i=0;i<nnx;i++) for(j=0;j<nny;j++) {
+void Histo2D::PutValue(TMatrix<r_8> &v, int_4 ierr)
+{
+//if(v.NRows()!=(uint_4)mNx || v.NCol()!=(uint_4)mNy) THROW(sizeMismatchErr);
+uint_4 nnx = (v.NRows()<(uint_4)mNx)? v.NRows(): (uint_4)mNx;
+uint_4 nny = (v.NCol() <(uint_4)mNy)? v.NCol() : (uint_4)mNy;
+if(nnx>0 && nny>0) for(uint_4 i=0;i<nnx;i++) for(uint_4 j=0;j<nny;j++) {
   (*this)(i,j) = v(i,j);
-  if(err2 && ierr) Error2(i,j) = fabs(v(i,j));
+  if(mErr2 && ierr) Error2(i,j) = fabs(v(i,j));
 }
 return;
@@ -572,13 +589,12 @@
   Addition du contenu de l'histo avec les valeurs d'un tableau.
 */
-void Histo2D::PutValueAdd(TMatrix<r_8> &v, int ierr)
-{
-int i,j;
-//if(v.NRows()!=(uint_4)nx || v.NCol()!=(uint_4)ny) THROW(sizeMismatchErr);
-uint_4 nnx = (v.NRows()<(uint_4)nx)? v.NRows(): (uint_4)nx;
-uint_4 nny = (v.NCol() <(uint_4)ny)? v.NCol() : (uint_4)ny;
-if(nnx>0 && nny>0) for(i=0;i<nnx;i++) for(j=0;j<nny;j++) {
+void Histo2D::PutValueAdd(TMatrix<r_8> &v, int_4 ierr)
+{
+//if(v.NRows()!=(uint_4)mNx || v.NCol()!=(uint_4)mNy) THROW(sizeMismatchErr);
+uint_4 nnx = (v.NRows()<(uint_4)mNx)? v.NRows(): (uint_4)mNx;
+uint_4 nny = (v.NCol() <(uint_4)mNy)? v.NCol() : (uint_4)mNy;
+if(nnx>0 && nny>0) for(uint_4 i=0;i<nnx;i++) for(uint_4 j=0;j<nny;j++) {
   (*this)(i,j) += v(i,j);
-  if(err2 && ierr) Error2(i,j) += fabs(v(i,j));
+  if(mErr2 && ierr) Error2(i,j) += fabs(v(i,j));
 }
 return;
@@ -591,11 +607,10 @@
 void Histo2D::PutError2(TMatrix<r_8> &v)
 {
-int i,j;
-//if(v.NRows()!=(uint_4)nx || v.NCol()!=(uint_4)ny) THROW(sizeMismatchErr);
-uint_4 nnx = (v.NRows()<(uint_4)nx)? v.NRows(): (uint_4)nx;
-uint_4 nny = (v.NCol() <(uint_4)ny)? v.NCol() : (uint_4)ny;
+//if(v.NRows()!=(uint_4)mNx || v.NCol()!=(uint_4)mNy) THROW(sizeMismatchErr);
+uint_4 nnx = (v.NRows()<(uint_4)mNx)? v.NRows(): (uint_4)mNx;
+uint_4 nny = (v.NCol() <(uint_4)mNy)? v.NCol() : (uint_4)mNy;
 if(nnx>0 && nny>0) {
-  if(!err2) Errors();
-  for(i=0;i<nnx;i++) for(j=0;j<nny;j++) Error2(i,j) = v(i,j);
+  if(!mErr2) Errors();
+  for(uint_4 i=0;i<nnx;i++) for(uint_4 j=0;j<nny;j++) Error2(i,j) = v(i,j);
 }
 return;
@@ -608,11 +623,10 @@
 void Histo2D::PutError2Add(TMatrix<r_8> &v)
 {
-int i,j;
-//if(v.NRows()!=(uint_4)nx || v.NCol()!=(uint_4)ny) THROW(sizeMismatchErr);
-uint_4 nnx = (v.NRows()<(uint_4)nx)? v.NRows(): (uint_4)nx;
-uint_4 nny = (v.NCol() <(uint_4)ny)? v.NCol() : (uint_4)ny;
+//if(v.NRows()!=(uint_4)mNx || v.NCol()!=(uint_4)mNy) THROW(sizeMismatchErr);
+uint_4 nnx = (v.NRows()<(uint_4)mNx)? v.NRows(): (uint_4)mNx;
+uint_4 nny = (v.NCol() <(uint_4)mNy)? v.NCol() : (uint_4)mNy;
 if(nnx>0 && nny>0) {
-  if(!err2) Errors();
-  for(i=0;i<nnx;i++) for(j=0;j<nny;j++)
+  if(!mErr2) Errors();
+  for(uint_4 i=0;i<nnx;i++) for(uint_4 j=0;j<nny;j++)
           if(v(i,j)>0.) Error2(i,j) += v(i,j);
 }
@@ -625,11 +639,10 @@
 void Histo2D::PutError(TMatrix<r_8> &v)
 {
-int i,j;
-//if(v.NRows()!=(uint_4)nx || v.NCol()!=(uint_4)ny) THROW(sizeMismatchErr);
-uint_4 nnx = (v.NRows()<(uint_4)nx)? v.NRows(): (uint_4)nx;
-uint_4 nny = (v.NCol() <(uint_4)ny)? v.NCol() : (uint_4)ny;
+//if(v.NRows()!=(uint_4)mNx || v.NCol()!=(uint_4)mNy) THROW(sizeMismatchErr);
+uint_4 nnx = (v.NRows()<(uint_4)mNx)? v.NRows(): (uint_4)mNx;
+uint_4 nny = (v.NCol() <(uint_4)mNy)? v.NCol() : (uint_4)mNy;
 if(nnx>0 && nny>0) {
-  if(!err2) Errors();
-  for(i=0;i<nnx;i++) for(j=0;j<nny;j++)
+  if(!mErr2) Errors();
+  for(uint_4 i=0;i<nnx;i++) for(uint_4 j=0;j<nny;j++)
     if(v(i,j)>0.) Error2(i,j)=v(i,j)*v(i,j); else Error2(i,j)= -v(i,j)*v(i,j);
 }
@@ -642,39 +655,39 @@
   Addition du contenu de l'histo pour x,y poids w.
 */
-void Histo2D::Add(float x, float y, float w)
+void Histo2D::Add(r_8 x, r_8 y, r_8 w)
 {
 list<bande_slice>::iterator it;
-int i,j;
+int_4 i,j;
 FindBin(x,y,i,j);
 
-if( hprojx != NULL ) hprojx->Add(x,w);
-if( hprojy != NULL ) hprojy->Add(y,w);
-
-if(lbandx.size()>0)
-  for( it = lbandx.begin(); it != lbandx.end(); it++)
+if( mHprojx != NULL ) mHprojx->Add(x,w);
+if( mHprojy != NULL ) mHprojy->Add(y,w);
+
+if(mLBandx.size()>0)
+  for( it = mLBandx.begin(); it != mLBandx.end(); it++)
     if( (*it).min <= y && y < (*it).max ) (*it).H->Add(x,w);
 
-if(lbandy.size()>0)
-  for( it = lbandy.begin(); it != lbandy.end(); it++)
+if(mLBandy.size()>0)
+  for( it = mLBandy.begin(); it != mLBandy.end(); it++)
     if( (*it).min <= x && x < (*it).max ) (*it).H->Add(y,w);
 
-if(lslix.size()>0)
-  for( it = lslix.begin(); it != lslix.end(); it++)
+if(mLSlix.size()>0)
+  for( it = mLSlix.begin(); it != mLSlix.end(); it++)
     if( (*it).min <= y && y < (*it).max ) (*it).H->Add(x,w);
 
-if(lsliy.size()>0)
-  for( it = lsliy.begin(); it != lsliy.end(); it++)
+if(mLSliy.size()>0)
+  for( it = mLSliy.begin(); it != mLSliy.end(); it++)
     if( (*it).min <= x && x < (*it).max ) (*it).H->Add(y,w);
 
-if( i<0 || i>=nx || j<0 || j>=ny ) {
-  if(i<0) i=0; else if(i>=nx) i=2; else i=1;
-  if(j<0) j=0; else if(j>=ny) j=2; else j=1;
-  over[i][j] += w;
-  over[1][1] += w;
+if( i<0 || i>=mNx || j<0 || j>=mNy ) {
+  if(i<0) i=0; else if(i>=mNx) i=2; else i=1;
+  if(j<0) j=0; else if(j>=mNy) j=2; else j=1;
+  mOver[i][j] += w;
+  mOver[1][1] += w;
   return;
 }
 
-data[j*nx+i] += w;
-if(err2!=NULL) err2[j*nx+i] += w*w;
+mData[j*mNx+i] += w;
+if(mErr2!=NULL) mErr2[j*mNx+i] += w*w;
 nHist += w;
 nEntries++;
@@ -685,19 +698,19 @@
   Recherche du bin du maximum dans le pave [il,ih][jl,jh].
 */
-void Histo2D::IJMax(int& imax,int& jmax,int il,int ih,int jl,int jh)
-{
-if( il > ih ) { il = 0; ih = nx-1; }
-if( jl > jh ) { jl = 0; jh = ny-1; }
+void Histo2D::IJMax(int_4& imax,int_4& jmax,int_4 il,int_4 ih,int_4 jl,int_4 jh)
+{
+if( il > ih ) { il = 0; ih = mNx-1; }
+if( jl > jh ) { jl = 0; jh = mNy-1; }
 if( il < 0 ) il = 0;
 if( jl < 0 ) jl = 0;
-if( ih >= nx ) ih = nx-1;
-if( jh >= ny ) jh = ny-1;
+if( ih >= mNx ) ih = mNx-1;
+if( jh >= mNy ) jh = mNy-1;
 
 imax = jmax = 0;
-if(nxy==1) return;
-
-float mx=(*this)(il,jl);
-for (int i=il; i<=ih; i++)
-   for (int j=jl; j<=jh; j++)
+if(mNxy==1) return;
+
+r_8 mx=(*this)(il,jl);
+for (int_4 i=il; i<=ih; i++)
+   for (int_4 j=jl; j<=jh; j++)
       if ((*this)(i,j)>mx) {imax = i; jmax = j; mx=(*this)(i,j);}
 }
@@ -706,19 +719,19 @@
   Recherche du bin du minimum dans le pave [il,ih][jl,jh].
 */
-void Histo2D::IJMin(int& imax,int& jmax,int il,int ih,int jl,int jh)
-{
-if( il > ih ) { il = 0; ih = nx-1; }
-if( jl > jh ) { jl = 0; jh = ny-1; }
+void Histo2D::IJMin(int_4& imax,int_4& jmax,int_4 il,int_4 ih,int_4 jl,int_4 jh)
+{
+if( il > ih ) { il = 0; ih = mNx-1; }
+if( jl > jh ) { jl = 0; jh = mNy-1; }
 if( il < 0 ) il = 0;
 if( jl < 0 ) jl = 0;
-if( ih >= nx ) ih = nx-1;
-if( jh >= ny ) jh = ny-1;
+if( ih >= mNx ) ih = mNx-1;
+if( jh >= mNy ) jh = mNy-1;
 
 imax = jmax = 0;
-if(nxy==1) return;
-
-float mx=(*this)(il,jl);
-for (int i=il; i<=ih; i++)
-   for (int j=jl; j<=jh; j++)
+if(mNxy==1) return;
+
+r_8 mx=(*this)(il,jl);
+for (int_4 i=il; i<=ih; i++)
+   for (int_4 j=jl; j<=jh; j++)
       if ((*this)(i,j)<mx) {imax = i; jmax = j; mx=(*this)(i,j);}
 }
@@ -728,17 +741,17 @@
   Recherche du maximum dans le pave [il,ih][jl,jh].
 */
-float Histo2D::VMax(int il,int ih,int jl,int jh) const
-{
-if( il > ih ) { il = 0; ih = nx-1; }
-if( jl > jh ) { jl = 0; jh = ny-1; }
+r_8 Histo2D::VMax(int_4 il,int_4 ih,int_4 jl,int_4 jh) const
+{
+if( il > ih ) { il = 0; ih = mNx-1; }
+if( jl > jh ) { jl = 0; jh = mNy-1; }
 if( il < 0 ) il = 0;
 if( jl < 0 ) jl = 0;
-if( ih >= nx ) ih = nx-1;
-if( jh >= ny ) jh = ny-1;
-
-float mx=(*this)(il,jl);
-if(nxy==1) return mx;
-for (int i=il; i<=ih; i++)
-   for (int j=jl; j<=jh; j++)
+if( ih >= mNx ) ih = mNx-1;
+if( jh >= mNy ) jh = mNy-1;
+
+r_8 mx=(*this)(il,jl);
+if(mNxy==1) return mx;
+for (int_4 i=il; i<=ih; i++)
+   for (int_4 j=jl; j<=jh; j++)
       if ((*this)(i,j)>mx) mx=(*this)(i,j);
 return mx;
@@ -748,17 +761,17 @@
   Recherche du minimum dans le pave [il,ih][jl,jh].
 */
-float Histo2D::VMin(int il,int ih,int jl,int jh) const
-{
-if( il > ih ) { il = 0; ih = nx-1; }
-if( jl > jh ) { jl = 0; jh = ny-1; }
+r_8 Histo2D::VMin(int_4 il,int_4 ih,int_4 jl,int_4 jh) const
+{
+if( il > ih ) { il = 0; ih = mNx-1; }
+if( jl > jh ) { jl = 0; jh = mNy-1; }
 if( il < 0 ) il = 0;
 if( jl < 0 ) jl = 0;
-if( ih >= nx ) ih = nx-1;
-if( jh >= ny ) jh = ny-1;
-
-float mx=(*this)(il,jl);
-if(nxy==1) return mx;
-for (int i=il; i<=ih; i++)
-   for (int j=jl; j<=jh; j++)
+if( ih >= mNx ) ih = mNx-1;
+if( jh >= mNy ) jh = mNy-1;
+
+r_8 mx=(*this)(il,jl);
+if(mNxy==1) return mx;
+for (int_4 i=il; i<=ih; i++)
+   for (int_4 j=jl; j<=jh; j++)
       if ((*this)(i,j)<mx) mx=(*this)(i,j);
 return mx;
@@ -769,5 +782,5 @@
   Renvoie les under.overflow dans les 8 quadrants.
   \verbatim
-     over[3][3]:        20 | 21 | 22
+     mOver[3][3]:       20 | 21 | 22
                            |    |
                        --------------
@@ -780,8 +793,8 @@
   \endverbatim
 */
-float Histo2D::NOver(int i,int j) const
-{
-if( i < 0 || i>=3 || j < 0 || j>=3 ) return over[1][1];
-return over[i][j];
+r_8 Histo2D::NOver(int_4 i,int_4 j) const
+{
+if( i < 0 || i>=3 || j < 0 || j>=3 ) return mOver[1][1];
+return mOver[i][j];
 }
 
@@ -791,8 +804,8 @@
   Retourne le nombre de bins non-nuls.
 */
-int Histo2D::BinNonNul() const
-{
-int non=0;
-for (int i=0;i<nxy;i++) if( data[i] != 0. ) non++;
+int_4 Histo2D::BinNonNul() const
+{
+int_4 non=0;
+for (int_4 i=0;i<mNxy;i++) if( mData[i] != 0. ) non++;
 return non;
 }
@@ -801,9 +814,9 @@
   Retourne le nombre de bins avec erreurs non-nulles.
 */
-int Histo2D::ErrNonNul() const
-{
-if(err2==NULL) return -1;
-int non=0;
-for (int i=0;i<nxy;i++) if( err2[i] != 0. ) non++;
+int_4 Histo2D::ErrNonNul() const
+{
+if(mErr2==NULL) return -1;
+int_4 non=0;
+for (int_4 i=0;i<mNxy;i++) if( mErr2[i] != 0. ) non++;
 return non;
 }
@@ -813,8 +826,8 @@
   Idem EstimeMax(int...) mais retourne x,y.
 */
-int Histo2D::EstimeMax(float& xm,float& ym,int SzPav
-                      ,int il,int ih,int jl,int jh)
-{
-int im,jm;
+int_4 Histo2D::EstimeMax(r_8& xm,r_8& ym,int_4 SzPav
+                      ,int_4 il,int_4 ih,int_4 jl,int_4 jh)
+{
+int_4 im,jm;
 IJMax(im,jm,il,ih,jl,jh);
 return EstimeMax(im,jm,xm,ym,SzPav);
@@ -833,21 +846,21 @@
   \endverbatim
 */
-int Histo2D::EstimeMax(int im,int jm,float& xm,float& ym,int SzPav)
+int_4 Histo2D::EstimeMax(int_4 im,int_4 jm,r_8& xm,r_8& ym,int_4 SzPav)
 {
 xm = ym = 0;
 if( SzPav <= 0 ) return -1;
-if( im < 0 || im >= nx ) return -1;
-if( jm < 0 || jm >= ny ) return -1;
+if( im < 0 || im >= mNx ) return -1;
+if( jm < 0 || jm >= mNy ) return -1;
 
 if( SzPav%2 == 0 ) SzPav++;
 SzPav = (SzPav-1)/2;
 
-int rc = 0;
-double dxm = 0, dym = 0, wx = 0;
-for(int i=im-SzPav;i<=im+SzPav;i++) {
-  if( i<0 || i>= nx ) {rc=1; continue;}
-  for(int j=jm-SzPav;j<=jm+SzPav;j++) {
-    if( j<0 || j>= ny ) {rc=1; continue;}
-    float x,y;
+int_4 rc = 0;
+r_8 dxm = 0, dym = 0, wx = 0;
+for(int_4 i=im-SzPav;i<=im+SzPav;i++) {
+  if( i<0 || i>= mNx ) {rc=1; continue;}
+  for(int_4 j=jm-SzPav;j<=jm+SzPav;j++) {
+    if( j<0 || j>= mNy ) {rc=1; continue;}
+    r_8 x,y;
     BinCenter(i,j,x,y);
     dxm += x * (*this)(i,j);
@@ -888,31 +901,31 @@
   \endverbatim
 */
-int Histo2D::FindMax(int& im,int& jm,int SzPav,float Dz
-                    ,int il,int ih,int jl,int jh)
-{
-if( il > ih ) { il = 0; ih = nx-1; }
-if( jl > jh ) { jl = 0; jh = ny-1; }
+int_4 Histo2D::FindMax(int_4& im,int_4& jm,int_4 SzPav,r_8 Dz
+                    ,int_4 il,int_4 ih,int_4 jl,int_4 jh)
+{
+if( il > ih ) { il = 0; ih = mNx-1; }
+if( jl > jh ) { jl = 0; jh = mNy-1; }
 if( il < 0 ) il = 0;
 if( jl < 0 ) jl = 0;
-if( ih >= nx ) ih = nx-1;
-if( jh >= ny ) jh = ny-1;
+if( ih >= mNx ) ih = mNx-1;
+if( jh >= mNy ) jh = mNy-1;
 if( SzPav < 0 ) SzPav = 0;
   else { if( SzPav%2 == 0 ) SzPav++; SzPav = (SzPav-1)/2;}
 if( Dz < 0 ) Dz = 0.;
-float max = VMax(il,ih,jl,jh) - Dz;
-int nmax = 0;
-float sumx = -MAXFLOAT;
-for(int i=il;i<=ih;i++) for(int j=jl;j<=jh;j++) {
+r_8 max = VMax(il,ih,jl,jh) - Dz;
+int_4 nmax = 0;
+r_8 sumx = -1.e20;
+for(int_4 i=il;i<=ih;i++) for(int_4 j=jl;j<=jh;j++) {
   if( (*this)(i,j) < max) continue;
   nmax++;
-  float sum = 0.;
-  for(int ii=i-SzPav;ii<=i+SzPav;ii++) {
-    if( ii<0 || ii >= nx ) continue;
-    for(int jj=j-SzPav;jj<=j+SzPav;jj++) {
-      if( jj<0 || jj >= ny ) continue;
+  r_8 sum = 0.;
+  for(int_4 ii=i-SzPav;ii<=i+SzPav;ii++) {
+    if( ii<0 || ii >= mNx ) continue;
+    for(int_4 jj=j-SzPav;jj<=j+SzPav;jj++) {
+      if( jj<0 || jj >= mNy ) continue;
       sum += (*this)(ii,jj);
     }
   }
-  if( sum > sumx ) { im = i; jm = j; sumx = sum;}
+  if(nmax==1 || sum>sumx) {im=i; jm=j; sumx=sum;}
 }
 if( nmax <= 0 ) { IJMax(im,jm,il,ih,jl,jh); return 1;}
@@ -943,5 +956,5 @@
   \endverbatim
 */
-int  Histo2D::Fit(GeneralFit& gfit,unsigned short typ_err)
+int_4  Histo2D::Fit(GeneralFit& gfit,unsigned short typ_err)
 {
 if(NBinX()*NBinY()<=0) return -1000;
@@ -950,10 +963,10 @@
 GeneralFitData mydata(2,NBinX()*NBinY());
 
-for(int i=0;i<NBinX();i++) for(int j=0;j<NBinY();j++) {
-  float x,y;
+for(int_4 i=0;i<NBinX();i++) for(int_4 j=0;j<NBinY();j++) {
+  r_8 x,y;
   BinCenter(i,j,x,y);
-  double f = (double) (*this)(i,j);
-  double saf = sqrt(fabs(f)); if(saf<1.) saf=1.;
-  double e=0.;
+  r_8 f = (*this)(i,j);
+  r_8 saf = sqrt(fabs(f)); if(saf<1.) saf=1.;
+  r_8 e=0.;
   if(typ_err==0)      {if(HasErrors()) e=Error(i,j); else e=1.;}
   else if(typ_err==1) {if(HasErrors()) e=Error(i,j); else e=saf;}
@@ -962,5 +975,5 @@
   else if(typ_err==4) e=(f==0.)?0.:1.;
   else if(typ_err==5) e=(f==0.)?0.:saf;
-  mydata.AddData2((double) x,(double) y,f,e);
+  mydata.AddData2(x,y,f,e);
 }
 
@@ -982,9 +995,9 @@
 TVector<r_8> par = gfit.GetParm();
 Histo2D h2(*this);
-for(int i=0;i<NBinX();i++) for(int j=0;j<NBinY();j++) {
-  float xc,yc;
+for(int_4 i=0;i<NBinX();i++) for(int_4 j=0;j<NBinY();j++) {
+  r_8 xc,yc;
   BinCenter(i,j,xc,yc);
-  double x[2] = {(double)xc,(double)yc};
-  h2(i,j) -= (float) f->Value(x,par.Data());
+  r_8 x[2] = {xc,yc};
+  h2(i,j) -= f->Value(x,par.Data());
 }
 return h2;
@@ -1003,9 +1016,9 @@
 TVector<r_8> par = gfit.GetParm();
 Histo2D h2(*this);
-for(int i=0;i<NBinX();i++) for(int j=0;j<NBinY();j++) {
-  float xc,yc;
+for(int_4 i=0;i<NBinX();i++) for(int_4 j=0;j<NBinY();j++) {
+  r_8 xc,yc;
   BinCenter(i,j,xc,yc);
-  double x[2] = {(double)xc,(double)yc};
-  h2(i,j) = (float) f->Value(x,par.Data());
+  r_8 x[2] = {xc,yc};
+  h2(i,j) = f->Value(x,par.Data());
 }
 return h2;
@@ -1020,10 +1033,10 @@
 printf("~Histo::Print    nHist=%g nEntries=%d",nHist,nEntries);
 if(HasErrors()) printf("  Errors=1\n"); else printf("  Errors=0\n");
-printf("over: [ %g %g %g // %g %g %g  // %g %g %g ]\n"
-      ,over[2][0],over[2][1],over[2][2]
-      ,over[1][0],over[1][1],over[1][2]
-      ,over[0][0],over[0][1],over[0][2]);
-printf("  nx=%d xmin=%g xmax=%g binx=%g  ",nx,xmin,xmax,wbinx);
-printf("  ny=%d ymin=%g ymax=%g biny=%g\n",ny,ymin,ymax,wbiny);
+printf("mOver: [ %g %g %g // %g %g %g  // %g %g %g ]\n"
+      ,mOver[2][0],mOver[2][1],mOver[2][2]
+      ,mOver[1][0],mOver[1][1],mOver[1][2]
+      ,mOver[0][0],mOver[0][1],mOver[0][2]);
+printf("  nx=%d xmin=%g xmax=%g binx=%g  ",mNx,mXmin,mXmax,mWBinx);
+printf("  ny=%d ymin=%g ymax=%g biny=%g\n",mNy,mYmin,mYmax,mWBiny);
 }
 
